@echo off
setlocal enableextensions
:init
set "currentdir=%~dp0%"
set "pythondir=%currentdir%lib\windows-i686\"
set "gamedir=%currentdir%game\"
set "PYTHONPATH=%pythondir%Lib"
cls
echo.
echo       RenCruncher - Ren'Py Game Compactor v0.4.1 BETA
echo.
echo                  by bas @ f95zone.to
echo.
echo  ----------------------------------------------------
reg Query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set OS=32BIT || set OS=64BIT
if %OS%==32BIT (
	echo    ! Error: This version of RenCruncher is only compatible with 64 bit versions
	echo             of Microsoft Windows, unable to continue.
	echo.
	pause>nul|set/p=.            Press any key to exit...
	exit
)
if not exist "Cruncher-x64" (
	echo    ! Error: Cannot locate RenCruncher folder, unable to continue.
	echo             Please move this file and RenCruncher folder to same folder as game exe.
	echo.
	pause>nul|set/p=.            Press any key to exit...
	exit
)
if not exist "game" (
	echo    ! Error: Cannot locate Ren'Py game folder, unable to continue.
	echo             Please move this file and RenCruncher folder to same folder as game exe.
	echo.
	pause>nul|set/p=.            Press any key to exit...
	exit
)
if not exist "Cruncher-x64\cwebp.exe" (
	echo    ! Error: Cannot locate cwebp.exe in RenCruncher folder, unable to continue.
  echo             Please unzip the entire contents of the RenCruncher zip file.
	echo.
	pause>nul|set/p=.            Press any key to exit...
	exit
)
if not exist "Cruncher-x64\ffmpeg.exe" (
	echo    ! Error: Cannot locate ffmpeg.exe, unable to continue.
  echo             Please unzip the entire contents of the RenCruncher zip file.
	echo.
	pause>nul|set/p=.            Press any key to exit...
	exit
)
:menu
echo.
echo    *** THIS TOOL OVERWRITES FILES IN THE REN'PY GAME ***
echo   *** IT DOES NOT MAKE BACKUPS OR SEND TO RECYCLE BIN ***
echo           ** CLOSE NOW IF YOU DON'T WANT THIS **
echo.
echo   Please select files to process:
echo     1) Image Files
echo     2) Audio Files
echo     3) Video Files
echo.
echo     6) All of the above
echo.
echo     Press 0 to Exit
echo.
set /p option=.  Enter a number:
echo.
echo  ----------------------------------------------------
echo.
if "%option%"=="1" goto images
if "%option%"=="2" goto audio
if "%option%"=="3" goto video
if "%option%"=="6" goto everything
if "%option%"=="0" exit
goto init

:images
set "type=image"
set "command-var="%CD%\Cruncher-x64\nconvert.exe" -out webp -o "%%~dpa%%~na".temp.webp -q 80 "%%a"
set "filetype=webp"
call :process
set "command-var="%CD%\Cruncher-x64\cwebp.exe" "%%a" -progress -q 80 -m 5 -mt -o "%%~dpa%%~na".temp."
set "filetype=jpg"
call :process
set "filetype=jpeg"
call :process
set "filetype=bmp"
call :process
set "filetype=png"
call :process
if not "%option%" == "6" (
	echo  ----------------------------------------------------
	echo   Summary:
	echo.
	echo   Processed %countwebp% webp, %countjpg% jpg, %countjpeg% jpeg, %countbmp% bmp, and %countpng% png image files.
  goto finish
) else (
	exit /b
)

:audio
set "type=audio"
set "command-var="%CD%\Cruncher-x64\ffmpeg.exe" -i "%%a" -map_metadata -1 -codec:a libopus -vn -b:a 32k -compression_level 10 -vbr on "%%~dpa%%~na".temp.ogg"
set "filetype=mp3"
call :process
set "filetype=wav"
call :process
set "filetype=ogg"
call :process
set "filetype=opus"
call :process
if not "%option%" == "6" (
	echo  ----------------------------------------------------
	echo   Summary:
	echo.
	echo   Processed %countmp3% mp3, %countogg% ogg, %countopus% opus, and %countwav% wav audio files.
	goto finish
) else (
	exit /b
)

:video
set "type=video"
set "command-var="%CD%\Cruncher-x64\ffmpeg.exe" -y -i "%%a" -c:v libvpx-vp9 -threads 8 -row-mt 1 -quality good -pass 1 -b:v 0 -crf 40 -speed 4 -tile-columns 4 -frame-parallel 1 -g 240 -vsync 2 -r 30 -an -f webm NUL"
set "command-var2="%CD%\Cruncher-x64\ffmpeg.exe" -i "%%a" -c:v libvpx-vp9 -threads 8 -row-mt 1 -quality good -pass 2 -b:v 0 -crf 40  -speed 1 -tile-columns 4 -frame-parallel 1 -auto-alt-ref 1 -lag-in-frames 25 -g 240 -vsync 2 -r 30 -c:a libopus -vbr on -compression_level 10 -frame_duration 60 -application audio -b:a 32k -f webm "%%~dpa%%~na".temp."
set "filetype=webm"
call :process
set "filetype=mp4"
call :process
set "filetype=mkv"
call :process
set "filetype=m4v"
call :process
set "filetype=mpg"
call :process
set "filetype=ogv"
call :process
set "filetype=avi"
call :process
if not "%option%" == "6" (
	echo  ----------------------------------------------------
	echo   Summary:
	echo.
	echo   Processed %countwebm% webm, %countmp4% mp4, %countmkv% mkv, %countm4v% m4v, %countmpg% mpg, %countogv% ogv, and %countavi% avi video files.
	goto finish
) else (
	exit /b
)

:Everything
call :images
call :audio
call :video
goto finish

:process
echo.
echo Looking for %filetype% %type% files to process...
echo.
set "count=0"
for /R "%CD%\game" %%a in (*.%filetype%) do (
	set /a count+=1
  echo Now processing %%a...
	echo.
	attrib -r "%%a"
	if "%filetype%"=="webp" (
		"%pythondir%python.exe" -O "%CD%\Cruncher-x64\webp-header-fix.py" "%%a"
		echo webp header rewritten, continuing...
		echo .
	)
	if "%type%"=="video" (
		%command-var%
		%command-var2%%filetype%
		del ffmpeg2pass-0.log
	) else if "%type%"=="audio" (
			%command-var%
	) else (
		if "%filetype%"=="webp" (
			%command-var%
			) else (
			%command-var%%filetype%
		)
	)
	if not "%type%"=="audio" (
		for %%I in ("%%~dpa%%~na.temp.%filetype%") do (
			if %%~zI==0 (
				Echo ERROR - New filesize is 0 bytes - reverting...
				del "%%~dpa%%~na".temp.%filetype%
			) else (
				echo Processing successful - replacing original...
				del "%%a"
				ren "%%~dpa%%~na".temp.%filetype% "%%~na.%filetype%"
			)
		)
	) else (
		for %%I in ("%%~dpa%%~na.temp.ogg") do (
				if %%~zI==0 (
					Echo ERROR - New filesize is 0 bytes - reverting...
					del "%%~dpa%%~na".temp.ogg
				) else (
					echo Processing successful - replacing original...
				  del "%%a"
					ren "%%~dpa%%~na".temp.ogg "%%~na.%filetype%"
				)
			)
		)
	Echo Processing of %%a completed.
	echo.
	)
echo.
set /a "count%filetype%=0"
set /a "count%filetype%=%count%"
if "%count%" == "0" (
	echo No %filetype% %type% files found.
  ) else (
echo Done - processed %count% %filetype% %type% files.
)
echo.
exit /b

:finish
if "%option%" == "6" (
  echo  ----------------------------------------------------
	echo   Summary:
	echo.
	echo   Processed %countwebp% webp, %countjpg% jpg, %countjpeg% jpeg, %countbmp% bmp, and %countpng% png image files.
	echo   Processed %countmp3% mp3, %countogg% ogg, %countopus% opus, and %countwav% wav audio files.
	echo   Processed %countwebm% webm, %countmp4% mp4, %countmkv% mkv, %countm4v% m4v, %countmpg% mpg, %countogv% ogv, and %countavi% avi video files.
)
echo  ----------------------------------------------------
echo.
echo    Finished!
echo.
echo    Enter "1" to go back to the menu, or any other
set /p exitoption=.   key to exit:
echo.
echo  ----------------------------------------------------
echo.
if "%exitoption%"=="1" goto menu
exit
